-- vlozi novy uzel do stromu
-- novy uzel je nejpravejsi potomek prvniho argumentu
create or replace function insert_node(text, text) returns void as $$
declare
	parent    alias for $1;
	new_label alias for $2;

	parent_rt integer;
begin
	select rt into parent_rt from tree where label = parent;
	update tree set lt = lt + 2 where lt > parent_rt;
	update tree set rt = rt + 2 where rt >= parent_rt;
	insert into tree (label, lt, rt) values (new_label, parent_rt, parent_rt + 1);
end;
$$ language 'plpgsql';

-- odstrani podstrom dany argumentem
create or replace function remove_subtree(text) returns void as $$
declare
	subtree alias for $1;

	drop_lt integer;
	drop_rt integer;
	gap integer;
begin
	select lt, rt into drop_lt, drop_rt from tree where label = subtree;
	gap := drop_rt - drop_lt + 1;
	delete from tree where lt between drop_lt and drop_rt;
	update tree set lt = lt - gap where lt > drop_lt;
	update tree set rt = rt - gap where rt > drop_lt;
end;
$$ language 'plpgsql';
